<script lang="ts">
  import { Card, Button, Dropdown, DropdownItem, ButtonGroup } from 'flowbite-svelte';
  import type { Competition, Link } from '@types';
  import { faChevronDown, faExternalLink } from '@fortawesome/free-solid-svg-icons';
  import Fa from 'svelte-fa';
  import Tag from '$lib/Tag.svelte';
  export let title: string;
  export let data: Competition;
  const placeholderDescription = 'No description available. Feel free to request or suggest one!';

  let clazz = '';
  export { clazz as class };

  function getLinkTrackingProps(link: Link) {
    return {
      'data-umami-event': 'Click External Competition Link',
      'data-umami-event-link': link.link,
      'data-umami-event-title': link.title,
      'data-umami-event-description': link.description,
      'data-umami-event-category': link.category
    };
  }
</script>

<Card class="text-center w-full grid row-span-4 grid-cols-subgrid grid-rows-subgrid {clazz}" padding="lg">
  <div>
    <h5 class="mb-2 text-3xl font-bold text-gray-900 dark:text-white">{title}</h5>
    <div class="justify-center items-center flex flex-wrap gap-2">
      {#if data.properties.tags.length > 0}
        {#each data.properties.tags as tag}
          <Tag {tag} />
        {/each}
      {/if}
    </div>
  </div>
  <p class="mb-5 text-base text-gray-600 sm:text-lg dark:text-gray-400">
    <slot>
      {data.properties.description || placeholderDescription}
    </slot>
  </p>
  <div class="justify-center items-center space-y-4 sm:flex sm:space-y-0 sm:space-x-4">
    <ButtonGroup divClass="inline-flex rounded-md shadow-sm">
      <Button
        color="light"
        href="/competitions/{encodeURIComponent(title)}"
        data-umami-event="View Competition Details"
        data-umami-event-competition={data.name}>Details</Button>
      <Button
        color="light"
        href={'/proxi-play?node=' + encodeURIComponent(title)}
        data-umami-event="View Competition On Map"
        data-umami-event-competition={data.name}>View on Map</Button>
      {#if data.properties.links?.length}
        {#if data.properties.links.length === 1}
          <!-- single link, display it without dropdown -->
          {#each data.properties.links as link}
            <Button
              color="light"
              target="_blank"
              href={link.link}
              {...getLinkTrackingProps(link)}
              data-umami-event-competition={data.name}>
              {link.title}
              <Fa class="pl-2" icon={faExternalLink} />
            </Button>
          {/each}
        {:else}
          <!-- multiple links, utilize a dropdown -->
          <Button color="light" data-umami-event="View Competition Links" data-umami-event-competition={data.name}>
            Links <Fa icon={faChevronDown} class="w-3 h-3 ms-2" />
          </Button>
          <Dropdown>
            {#each data.properties.links as link}
              <DropdownItem
                target="_blank"
                href={link.link}
                {...getLinkTrackingProps(link)}
                data-umami-event-competition={data.name}>
                {link.title}
              </DropdownItem>
            {/each}
          </Dropdown>
        {/if}
      {/if}
    </ButtonGroup>
  </div>
</Card>
